%im=double(imread('einstein.jpg'));

clear, close all

im=zeros(256,256);
im(100:120,100:120)=100;

tr=abs(fftshift(fft2(im)));
figure(1), clf
imshow(im,[])
figure(2), clf
imshow(log(tr),[])

figure(3), clf
imshow(tr)

figure(4)
mesh(tr)

% zero padding
tr=abs(fftshift(fft2(im, 512, 512)));
figure(1), clf
imshow(im,[])
figure(2), clf
imshow(log(tr),[])

figure(3), clf
imshow(tr)

figure(4)
mesh(tr), axis tight

% magnitude and phase
im=double(imread('einstein.tif'));
imt=(fft2(im));
imrec=(ifft2(imt)); figure, % imshow(imrec,[])

a=abs(imt);
ima=ifft2(a);

ph=angle(imt);
figure, imshow(ph);

%%%%% ERROR imph=ifft2(ph); 

% RICOSTRUIRE IMPONENDO O FASE NULLA (ABS) O MODULO=1
figure, imshow(log(fftshift(ifft2(a))),[])
re=cos(ph);
c=sin(ph);
test=re+j*c;
figure, imshow(ifft2(test),[])

% se voglio riportarle al centro devo fare fftshift
figure, imshow(ima,[]);
figure, imshow(imph,[]);

% interpolation non funziona perche non simmetrizza automaticamente
imint=ifft2(imt,512,512)
figure,imshow(imint)

% Altre cose: cambiare dimensione quadrato, costruire sinusoide lungo x e
% y, aggiungere rumore

H=fspecial('average',7);
Hf=fft2(H,256,256);
test=fftshift(Hf);
figure, mesh(abs(test)), axis tight

imf=imt.*Hf;
%figure, imshow(log(abs(imt)));
%figure, imshow(log(abs(imf)));

imrecf=ifft2(imf); figure, imshow(imrecf,[])

% changing filter size
H=fspecial('average',15);
Hf=fft2(H,256,256);
test=fftshift(Hf);
figure, mesh(abs(test)), axis tight

imf=imt.*Hf;
%figure, imshow(log(abs(imt)));
%figure, imshow(log(abs(imf)));

imrecf=ifft2(imf); figure, imshow(imrecf,[])

% prova
imfs=imfilter(im,H);
figure, imshow(imfs,[]);



